package org.saev.deob;

import java.util.Iterator;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;

public abstract class ApplicationTransformer implements Transformer<Application> {

	protected ApplicationTransformer() {}

	public void transform(Application app) {
	
		for(Iterator<ClassGen> appIt = app.getClasses().iterator(); appIt.hasNext(); ) {
			ClassGen cgen = appIt.next();
			Method[] methods = cgen.getMethods();
			
			for(int i = 0; i < methods.length; i++) {
				Method m = internalTransform(new MethodGen(methods[i], cgen.getClassName(), cgen.getConstantPool()));
				
				if(m != null) {
					cgen.replaceMethod(methods[i], m);
				}
			}
		}
	}

	protected abstract Method internalTransform(MethodGen mg);

	public abstract String getName();

	public abstract String getDescription();

	public abstract String getAuthor();
}
